Syncfusion AI Assistant

How can I help you?

Integrate Chart in EJ2 EJ2 JavaScript Grid

30 Jun 202524 minutes to read

The Grid and Chart Integration feature in Syncfusion allows users to visualize tabular data in a graphical format by linking the Grid with the Chart.This feature allows seamless integration with Charts to visualize selected data interactively. You can generate various Chart types such as bar, line, or pie directly from Grid data using the ContextMenu feature. This feature is particularly useful in scenarios where tabular data can be better understood through graphical representation.

This feature is particularly useful in dashboards, reporting tools, and data-driven applications where both tabular and visual representations of data are required.

Steps for Chart integration

To integrate Charts into your EJ2 EJ2 JavaScript Grid, follow these steps:

Dependencies

Below is the list of minimum dependencies required to integrate Chart functionality into the EJ2 EJ2 JavaScript Grid:

|-- dependencies
  |-- @syncfusion/ej2-grids
    |-- @syncfusion/ej2-base
    |-- @syncfusion/ej2-buttons
    |-- @syncfusion/ej2-dropdowns
    |-- @syncfusion/ej2-inputs
    |-- @syncfusion/ej2-navigations
    |-- @syncfusion/ej2-popups
  |-- @syncfusion/ej2-charts
  |-- @syncfusion/ej2-grid-chart

Setup for local development

Refer to the following steps to set up your local environment.

Step 1: Create a root folder named my-app for your application.

Step 2: Create a my-app/resources folder to store local scripts and styles files.

Step 3: Open Visual Studio Code and create my-app/index.js and my-app/index.html files for initializing the Essential JS 2 Syncfusion control.

Adding Syncfusion resources

The Essential JS 2 Grid and GridChart can be initialized by using either of the following ways.

Chart integration via Context Menu in Grid

This section explains how to dynamically render Charts based on user interactions within the Syncfusion EJ2 JavaScript Grid using the context menu. Users can right-click on selected rows and choose from various Chart types such as bar, pie, line Charts etc to visualize the data instantly. This feature enhances interactivity and provides a seamless analytical experience.

For example, in a sales dashboard, you can select sales records for specific products and instantly view a comparative bar or pie Chart illustrating online sales versus retail sales or revenue trends over several month. This functionality helps improve decision-making by providing immediate visual feedback.

Steps to be followed to integrate Chart into Grid via contextmenu:

Step 1: Define Chart options to Grid Context Menu:

Add Chart visualization options as context menu items within the Grid configuration using contextMenuItems property. These items allow you to right-click on selected rows and choose a Chart type to visualize the data.

contextMenuItems: [
  'Bar', 'StackingBar', 'StackingBar100',
  'Pie','Column', 'StackingColumn', 'StackingColumn100',
  'Line', 'StackingLine', 'StackingLine100',
  'Area', 'StackingArea', 'StackingArea100','Scatter'
]

Step 2: Initialize GridChart instance on Grid creation:

Inside the Grid’s created event, instantiate a GridChart object. This instance will be used to render Charts dynamically based on the selected Grid data.

created: () => {
  gridChart = new GridChart({
    enableRtl: grid.enableRtl,
    locale: grid.locale
  });
}

This ensures that the Chart instance is ready as soon as the Grid is initialized, allowing seamless interaction through the context menu.

Step 3: Handle context menu click to render Chart:

Use the contextMenuClick event to detect which Chart type was selected and render the Chart accordingly using the GridChart.render() method.

ContextMenuClick event passes the below arguments:

  • args.chartType: The selected Chart type.

  • args.gridInstance: The current Grid instance.

  • args.records: The selected data records to be visualized in the Chart.

  • Use the gridChart.render to render the Chart. It accepts three arguments discussed below:

    • chartArgs: Contains Grid instance, Chart type, and selected records.

    • chartModel: This specifies various Chart configurations related to the appearance and behavior of the Chart. The model allows you to configure axes, labels, legends, tooltips, and other Chart attributes. Refer to Syncfusion’s Chart Model for detailed configurations, options, and customization possibilities.

    • categorySeries: This specifies the fields in your data used for categories and series in the Chart.

      • Category fields: Define the grouping axis.
      • Series fields: Define the actual values plotted on the Chart.
  contextMenuClick: (args) => {
    // Check if the Chart type is defined in the clicked context menu item.
    if (args.chartType) {
      
      // Prepare the Chart arguments including the Grid instance, Chart type, and records to plot.
      const chartArgs = {
        gridInstance: args.gridInstance,
        chartType: args.chartType,
        records: args.records 
      };

      // Set up the Chart model configurations.
      const chartModel = {
        primaryXAxis: {
          valueType: 'Category',
          labelRotation: 315
        },
      };

      // Combine both Chart models into a single model for rendering.
      const model = { chart: chartModel, accumulationChart: {} };

      // Determine fields for category and series data in the Chart.
      const categorySeries = {
        category: ['Product', 'Month'], 
        series: ['Online', 'Retail'] 
      };

      // Render the Chart using the configured arguments and models.
      // The render function uses the defined chartArgs, model, and categorySeries to display the Chart.
      gridChart.render(chartArgs, model, categorySeries);
    }
}

The following complete example demonstrates how to integrate Charts into a Grid context menu using the contextMenuClick event with gridChart.render method:

ej.grids.Grid.Inject(ej.grids.ContextMenu);

let gridChart;
let grid = new ej.grids.Grid({
  dataSource: salesDatas,
  height: 416,
  allowSelection: true,
  selectionSettings: { type: 'Multiple' },
  contextMenuItems: [
    'Bar', 'StackingBar', 'StackingBar100',
    'Pie','Column', 'StackingColumn', 'StackingColumn100',
    'Line', 'StackingLine', 'StackingLine100',
    'Area', 'StackingArea', 'StackingArea100','Scatter'
  ],
  columns: [
    { type: 'checkbox', width: 50 },
    { field: 'Product', headerText: 'Products', width: 200 },
    { field: 'Month', headerText: 'Month', width: 160 },
    { field: 'Online', headerText: 'Online', format: 'C2', textAlign: 'Right', width: 160 },
    { field: 'Retail', headerText: 'Retail', format: 'C2', textAlign: 'Right', width: 160 },
    { field: 'Total', headerText: 'Total', format: 'C2', textAlign: 'Right', width: 160 },
  ],
  created: () => {
    gridChart = new ej.gridchart.GridChart({
      enableRtl: grid.enableRtl,
      locale: grid.locale,
    });
  },
  contextMenuClick: (args) => {
    if (args.chartType) {
      const chartArgs = {
        gridInstance: args.gridInstance,
        chartType: args.chartType,
        records: args.records
      };
      const chartModel  = {
        primaryXAxis: {
          valueType: 'Category',
          labelRotation: 315
        }
      };
      const model = {
        chart: chartModel,
        accumulationChart: { }
      };
      const categorySeries = {
        category: ['Product', 'Month'],
        series: ['Online', 'Retail']
      };
      gridChart.render(chartArgs, model, categorySeries);
    }
  }
});
grid.appendTo('#GridChart');
<!DOCTYPE html>
<html lang="en">

<head>
  <title>EJ2 Grid</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="Typescript Grid Control">
  <meta name="author" content="Syncfusion">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-grids/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-dropdowns/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-lists/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-inputs/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-calendars/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-grid-chart/styles/bootstrap5.css" rel="stylesheet" />
  <script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
  <script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>

  <div id='container'>
    <div id="GridChart"></div>
  </div>

  <script>
    var ele = document.getElementById('container');
    if (ele) {
      ele.style.visibility = "visible";
    }
  </script>
  <script src="index.js" type="text/javascript"></script>
</body>

</html>

Enable export functionality in GridChart

The export functionality in GridChart allows Charts to be saved or shared externally in various formats. This is particularly useful for preserving visualized data or including Charts in reports and presentations.

To enable this feature, set the allowExport property to true when creating the GridChart instance. Once enabled, an export option appears in the Chart popup toolbar, allowing the Chart to be exported in various formats such as PDF, CSV, Print, JPEG, XLSX, SVG, and PNG.

The following code snippet demonstrates how to enable export functionality in GridChart:

gridChart = new GridChart({
  allowExport: true
});

Enable property panel in GridChart

The property panel in GridChart provides a built-in interface to modify Chart settings dynamically at runtime. By default, the property panel is disabled. To enable it, set the enablePropertyPanel option to true during the instantiation of the GridChart object. Here’s how to do it:

gridChart = new GridChart({
  enablePropertyPanel: true
});

When enabled, the property panel appears alongside the Chart popup and offers three main configuration sections:

  • Chart Types: Choose from a variety of Chart types, including Column, Line, Pie, and others.

  • Chart Data: Configure the category axis and series fields for data visualization.

  • Formatting Options: Adjust styling properties such as Chart style, title style, legend appearance, series settings, and axes formatting.

    • Chart Style:

      • Margin : Adjust the margins around the Chart (top, bottom, left, right) for better layout spacing.
      • Color: Set distinct colors for different Chart elements to improve visual clarity.
    • Title Style

      • Legend - Toggle the visibility of the legend and customize its font, size, color, and position.
      • Series - Enable/disable tooltips and customize Series color and data labels based on categories such as online, retail, or revenue.
    • Axes: - Select axes as either category or value type, and customize:

      • Reverse Order to change the data sequence.
      • Title: Adjust text, font, size, color, and rotation.
      • Label: Modify text, font, size, color, and rotation for better label presentation.

customize the Chart model:

You can customize the Chart by defining a chartModel object in the chart property of the model object within the contextMenuClick event .This allows you to configure various Chart properties such as axes, margins, tooltips, titles, and more. Additionally, you can use the events of the Chart within the chartModel configuration to apply further customizations when the Chart is rendered.

To customize Accumulation Charts (such as Pie), use the accumulationChart property of the model object. This property allows you to configure Chart options like titles, legends, data labels, and visual styles tailored for accumulation-type visualizations. You can also use Accumulation Chart events to apply additional customizations when the Chart is rendered.

The following code snippets demonstrate how to achieve this:

contextMenuClick: (args) => {
  if (args.chartType) {
    const chartModel = {
      primaryXAxis: {
      valueType: 'Category',
      labelRotation: 315,
    },
    margin: {
      top: 20,
      bottom: 20,
      right: 20,
      left: 20
    },
    tooltip: {
      enable: true,
      textStyle: {
        size: '16px',
        fontFamily: 'Arial, Helvetica, sans-serif'
      }
    },
    title: 'Sales Data',
    titleStyle: {
      size: '24px',
      fontFamily: 'Arial, Helvetica, sans-serif',
      fontWeight: 'Bold'
    },
    subTitle: 'Sales data for various products over the months',
    load: (args) => {
      if (args.chart.titleStyle) {
        args.chart.titleStyle.color = '#1976d2';
      }
    }
  };
  const accumulationChartModel = {
    title :'Sales Distribution'
  };
  const model = {
    chart: chartModel,
      accumulationChart: accumulationChartModel
    };
  }
}

You can also programmatically update the Chart’s appearance using the updateChartSettings(args: UpdateChartArgs) event provided by the GridChart integration. This event is triggered when you modify Chart properties through the Chart popup’s property panel. This is useful for applying custom themes, adjusting axis settings, or modifying series styles.

The following code snippet demonstrates how to dynamically customize chart margins and restrict their values to a minimum of 20 using the updateChartSettings event.

created: () => {
  gridChart = new GridChart({
    enablePropertyPanel: true,
    updateChartSettings: updateChartSettings
  });
});

function updateChartSettings(args) {
  const chart = args.changes?.chart;
  if (!chart) return;

  // Restrict margin values to minimum 20.
  const margin = chart.margin;
  if (margin) {
    if ( margin.top < 20) margin.top = 20;
    if (margin.bottom < 20) margin.bottom = 20;
    if (margin.left < 20) margin.left = 20;
    if (margin.right < 20) margin.right = 20;
  }
}

The following complete example demonstrates how to enable the property panel by setting enablePropertyPanel to true, customize the chart using the chartModel within contextMenuClick event, and dynamically control or customize the behavior of the updateChartSettings event.

ej.grids.Grid.Inject(ej.grids.ContextMenu);
let gridChart;
let grid = new ej.grids.Grid(
  {
    dataSource: salesDatas,
    height: 416,
    allowSelection: true,
    selectionSettings: { type: 'Multiple' },
    contextMenuItems: [
      'Bar', 'StackingBar', 'StackingBar100',
      'Pie', 'Column', 'StackingColumn', 'StackingColumn100',
      'Line', 'StackingLine', 'StackingLine100',
      'Area', 'StackingArea', 'StackingArea100', 'Scatter'
    ],
    columns: [
      { type: 'checkbox', width: 50 },
      { field: 'Product', headerText: 'Products', width: 200 },
      { field: 'Month', headerText: 'Month', width: 160 },
      { field: 'Online', headerText: 'Online', format: 'C2', textAlign: 'Right', width: 160 },
      { field: 'Retail', headerText: 'Retail', format: 'C2', textAlign: 'Right', width: 160 },
      { field: 'Total', headerText: 'Total', format: 'C2', textAlign: 'Right', width: 160 },
    ],
    created: () => {
      gridChart = new ej.gridchart.GridChart({
        enablePropertyPanel: true,
        allowExport: true,
        enableRtl: grid.enableRtl,
        locale: grid.locale,
        updateChartSettings: updateChartSettings
      });
    },
    contextMenuClick: (args) => {
      if (args.chartType) {
        const chartArgs= {
          gridInstance: (args.gridInstance),
          chartType: args.chartType,
          records: (args.records),
        };
        const chartModel = {
          primaryXAxis: {
            valueType: 'Category',
            labelRotation: 315,
          },
          margin: {
            top: 20,
            bottom: 20,
            right: 20,
            left: 20
          },
          tooltip: {
            enable: true,
            textStyle: {
              size: '16px',
              fontFamily: 'Arial, Helvetica, sans-serif'
            }
          },
          title: 'Sales Data',
          titleStyle
            : {
            size: '24px',
            fontFamily: 'Arial, Helvetica, sans-serif',
            fontWeight: 'Bold'
          },

          subTitle: 'Sales data for various products over the months',
          load: (args) => {
            if (args.chart.titleStyle) {
              args.chart.titleStyle.color = '#1976d2';
            }
          }
        };
        const accumulationChartModel= {
          title :'Sales Distribution'
        };
        const model = {
          chart: chartModel,
          accumulationChart: accumulationChartModel
        };
        const categorySeries = {
          category: ['Product', 'Month'],
          series: ['Online', 'Retail']
        };
        gridChart.render(chartArgs, model, categorySeries);
      }
    }
  });
grid.appendTo('#GridChart');

function updateChartSettings(args) {
  const chart = args.changes?.chart;
  if (!chart) return;

  // Restrict margin values to minimum 20.
  const margin = chart.margin;
  if (margin) {
    if ( margin.top < 20) margin.top = 20;
    if (margin.bottom < 20) margin.bottom = 20;
    if (margin.left < 20) margin.left = 20;
    if (margin.right < 20) margin.right = 20;
  }
}
<!DOCTYPE html>
<html lang="en">

<head>
  <title>EJ2 Grid</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="Typescript Grid Control">
  <meta name="author" content="Syncfusion">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-grids/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-dropdowns/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-lists/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-inputs/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-calendars/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/bootstrap5.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-grid-chart/styles/bootstrap5.css" rel="stylesheet" />
  <script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
  <script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>

  <div id='container'>
    <div id="GridChart"></div>
  </div>

  <script>
    var ele = document.getElementById('container');
    if (ele) {
      ele.style.visibility = "visible";
    }
  </script>
  <script src="index.js" type="text/javascript"></script>
</body>

</html>

Integrate Chart in Syncfusion Vue Grid

27 Jun 202524 minutes to read

The Grid and Chart Integration feature in Syncfusion allows users to visualize tabular data in a graphical format by linking the Grid with the Chart.This feature allows seamless integration with Charts to visualize selected data interactively. You can generate various Chart types such as bar, line, or pie directly from Grid data using the ContextMenu feature. This feature is particularly useful in scenarios where tabular data can be better understood through graphical representation.

This feature is particularly useful in dashboards, reporting tools, and data-driven applications where both tabular and visual representations of data are required.

Steps for Chart integration

To integrate Charts into your Grid, follow these steps:

Dependencies

Below is the list of minimum dependencies required to integrate Chart functionality into the Grid:

|-- dependencies
  |-- @syncfusion/ej2-grid-chart
    |--@syncfusion/ej2-vue-grids
    |-- @syncfusion/ej2-base
    |-- @syncfusion/ej2-buttons
    |-- @syncfusion/ej2-dropdowns
    |-- @syncfusion/ej2-grids
    |-- @syncfusion/ej2-inputs
    |-- @syncfusion/ej2-navigations
    |-- @syncfusion/ej2-popups
    |-- @syncfusion/ej2-splitbuttons
    |-- @syncfusion/ej2-notifications
    |-- @syncfusion/ej2-calendars
    |-- @syncfusion/ej2-charts

Setup for local development

To get started with Syncfusion components in your Vue project, refer to the appropriate documentation based on your Vue version:

For Vue 3:

Refer to the Vue 3 Getting Started with Vite guide for step-by-step instructions.

For Vue 2:

Refer to the Vue 2 Getting Started guide for detailed setup steps.

Add Syncfusion Vue packages

Syncfusion Vue component packages are available at npmjs.com. To use Syncfusion Vue components in your project, install the corresponding npm packages.

To install the Grid-Chart package, use the following command:

npm install @syncfusion/ej2-grid-chart --save

or

yarn add @syncfusion/ej2-grid-chart

Import the Syncfusion CSS styles

You can import themes for the Syncfusion Vue component in various ways, such as using CSS or SASS styles from npm packages, CDN, CRG and Theme Studio. Refer to themes topic to know more about built-in themes and different ways to refer to themes in a Vue project.

In this article, Tailwind theme is applied using CSS styles, which are available in installed packages. The necessary tailwind CSS styles for the Grid and GridChart and its dependents were imported into the

@import "../node_modules/@syncfusion/ej2-base/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-calendars/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/tailwind.css";
@import '../node_modules/@syncfusion/ej2-grid-chart/styles/tailwind.css';

The order of importing CSS styles should be in line with its dependency graph.

Chart integration via Context Menu in Grid

This section explains how to dynamically render Charts based on user interactions within the Syncfusion Vue Grid using the context menu. Users can right-click on selected rows and choose from various Chart types such as bar, pie, line Charts etc to visualize the data instantly. This feature enhances interactivity and provides a seamless analytical experience.

For example, in a sales dashboard, you can select sales records for specific products and instantly view a comparative bar or pie Chart illustrating online sales versus retail sales or revenue trends over several month. This functionality helps improve decision-making by providing immediate visual feedback.

Steps to be followed to integrate Chart into Grid via Context Menu:

Step 1. Inject required modules:

Import the necessary modules from the Grid and GridChart packages, and inject the ContextMenu module into the Grid to enable context menu functionality.

import { GridComponent, ColumnDirective, ColumnsDirective, ContextMenu } from '@syncfusion/ej2-vue-grids';
import { GridChart } from '@syncfusion/ej2-grid-chart';

export default {
  components: {
    'ejs-grid': GridComponent,
    'e-column': ColumnDirective,
    'e-columns': ColumnsDirective
  },
  provide: {
    grid: [ContextMenu]
  }
}
import { GridComponent as EjsGrid, ColumnDirective as EColumn, ColumnsDirective as EColumns, ContextMenu } from "@syncfusion/ej2-vue-grids";
import { GridChart } from '@syncfusion/ej2-grid-chart';

provide('grid', [ContextMenu]);

Step 2: Define Chart options to Grid Context Menu:

Add Chart visualization options as context menu items within the Grid configuration using contextMenuItems property. These items allow you to right-click on selected rows and choose a Chart type to visualize the data.

export default {
  data: () => {
    return {
      contextMenuItems: ['Bar', 'StackingBar', 'StackingBar100', 'Pie',
        'Column', 'StackingColumn', 'StackingColumn100',
        'Line', 'StackingLine', 'StackingLine100',
        'Area', 'StackingArea', 'StackingArea100',
        'Scatter'
      ]    
    }
  }
}
const contextMenuItems = [
  'Bar', 'StackingBar', 'StackingBar100', 
  'Pie','Column', 'StackingColumn', 
  'StackingColumn100','Line', 'StackingLine', 
  'StackingLine100','Area', 'StackingArea', 
  'StackingArea100','Scatter'
];

Step 3: Initialize GridChart instance on Grid creation:

Inside the Grid’s created event, instantiate a GridChart object. This instance will be used to render Charts dynamically based on the selected Grid data.

export default {
  methods: {
    created() {
      var grid = this.$refs.gridInstance.$el.ej2_instances[0];
      this.gridChart = new GridChart({
        enableRtl: grid.enableRtl,
        locale: grid.locale,
      });
    }
  }
}
const gridInstance=ref(null);

const created = () => {
  gridChart.value = new GridChart({
    enableRtl: gridInstance.value.enableRtl,
    locale: gridInstance.value.locale,
  });
};

This ensures that the Chart instance is ready as soon as the Grid is initialized, allowing seamless interaction through the context menu.

Step 4: Handle context menu click to render Chart:

Use the contextMenuClick event to detect which Chart type was selected and render the Chart accordingly using the gridChart.render() method.

ContextMenuClick event passes the below arguments:

  • args.chartType: The selected Chart type.

  • args.gridInstance: The current Grid instance.

  • args.records: The selected data records to be visualized in the Chart.

  • Use the gridChart.render to render the Chart. It accepts three arguments discussed below:

    • chartArgs: Contains Grid instance, Chart type, and selected records.

    • chartModel: This specifies various Chart configurations related to the appearance and behavior of the Chart. The model allows you to configure axes, labels, legends, tooltips, and other Chart attributes. Refer to Syncfusion’s Chart Model for detailed configurations, options, and customization possibilities.

    • categorySeries: This specifies the fields in your data used for categories and series in the Chart.

      • Category fields: Define the grouping axis.
      • Series fields: Define the actual values plotted on the Chart.
export default {
  methods: {
    contextMenuClick(args) {
      // Check if the Chart type is defined in the clicked context menu item.
      if (args.chartType && args.gridInstance) {
        // Prepare the Chart arguments including the Grid instance, Chart type, and records to plot.
        const chartArgs = {
          gridInstance: args.gridInstance,
          chartType: args.chartType,
          records: args.records,
        };

        // Set up the Chart model configurations.
        const chartModel = {
          primaryXAxis: {
            valueType: 'Category',
            labelRotation: 315,
          }
        };

         // Combine both Chart models into a single model for rendering.
        const model= {
          chart: chartModel,
          accumulationChart: { }
        };

        // Determine fields for category and series data in the Chart.
        const categorySeries= {
          category: ['Product', 'Month'],
          series: ['Online', 'Retail']
        };

        // Render the Chart using the configured arguments and models.
        // The render function uses the defined chartArgs, model, and categorySeries to display the Chart.
        this.gridChart.render(chartArgs, model, categorySeries);
      }
    }
  }
}
const contextMenuClick = (args) => {
  // Check if the Chart type is defined in the clicked context menu item.
  if (args.chartType && args.gridInstance) {

    // Prepare the Chart arguments including the Grid instance, Chart type, and records to plot.
    const chartArgs = {
      gridInstance: args.gridInstance,
      chartType: args.chartType,
      records: args.records,
    };

    // Set up the Chart model configurations.
    const chartModel = {
      primaryXAxis: {
        valueType: 'Category',
        labelRotation: 315,
      }
    };

    // Combine both Chart models into a single model for rendering.
    const model= {
      chart: chartModel,
      accumulationChart: { }
    };

    // Determine fields for category and series data in the Chart.
    const categorySeries= {
      category: ['Product', 'Month'],
      series: ['Online', 'Retail']
    };

    // Render the Chart using the configured arguments and models.
    // The render function uses the defined chartArgs, model, and categorySeries to display the Chart.
    gridChart.value.render(chartArgs, model, categorySeries);
  }
};

The following complete example demonstrates how to integrate charts into a Grid context menu using the contextMenuClick event with gridChart.render method:

<template>
  <div class="col-lg-12 control-section">
    <div class="content-wrapper">
      <ejs-grid ref='gridInstance' id='GridChart' :dataSource='data' :height="417" :allowSelection="true" :selectionSettings="selectionSettings"
      :contextMenuItems="contextMenuItems" :contextMenuClick="contextMenuClick" :created="created">
        <e-columns>
          <e-column type='checkbox' width='50'></e-column>
          <e-column field='Product' headerText='Products' width='200' ></e-column>
          <e-column field='Month' headerText='Month' width='140' ></e-column>
          <e-column field='Online' headerText='Online' format='C2' textAlign='Right' width='160'></e-column>
          <e-column field='Retail' headerText='Retail' format='C2' textAlign='Right' width='160'></e-column>
          <e-column field='Total' headerText='Total' format='C2' textAlign='Right' width='160' ></e-column>
        </e-columns>
      </ejs-grid>
    </div>
  </div>
</template>

<script setup>
import { GridComponent as EjsGrid, ColumnDirective as EColumn, ColumnsDirective as EColumns, ContextMenu } from "@syncfusion/ej2-vue-grids";
import { salesDatas } from "./datasource.js";
import { provide, ref } from "vue";
import { GridChart } from '@syncfusion/ej2-grid-chart';

const gridInstance=ref(null);
const data = salesDatas;
const selectionSettings = { type: 'Multiple' };
const contextMenuItems = ['Bar', 'StackingBar', 'StackingBar100', 'Pie',
  'Column', 'StackingColumn', 'StackingColumn100',
  'Line', 'StackingLine', 'StackingLine100',
  'Area', 'StackingArea', 'StackingArea100',
  'Scatter'
];
let gridChart = ref(null);

const created = () => {
  gridChart.value = new GridChart({
    enableRtl: gridInstance.value.enableRtl,
    locale: gridInstance.value.locale,
  });
};

const contextMenuClick = (args) => {
  if (args.chartType && args.gridInstance) {
    const chartArgs = {
      gridInstance: args.gridInstance,
      chartType: args.chartType,
      records: args.records,
    };
    const chartModel = {
      primaryXAxis: {
        valueType: 'Category',
        labelRotation: 315,
      }
    };
    const model= {
      chart: chartModel,
      accumulationChart: { }
    };
    const categorySeries= {
      category: ['Product', 'Month'],
      series: ['Online', 'Retail']
    };
    gridChart.value.render(chartArgs, model, categorySeries);
  }
};

provide('grid', [ContextMenu]);
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-calendars/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/tailwind.css";
@import '../node_modules/@syncfusion/ej2-grid-chart/styles/tailwind.css';
</style>
<template>
  <div class="col-lg-12 control-section">
    <div class="content-wrapper">
      <ejs-grid ref='gridInstance' id='GridChart' :dataSource='data' :height="417" :allowSelection="true" :selectionSettings="selectionSettings"
      :contextMenuItems="contextMenuItems" :contextMenuClick="contextMenuClick" :created="created">
        <e-columns>
          <e-column type='checkbox' width='50'></e-column>
          <e-column field='Product' headerText='Products' width='200' ></e-column>
          <e-column field='Month' headerText='Month' width='140' ></e-column>
          <e-column field='Online' headerText='Online' format='C2' textAlign='Right' width='160'></e-column>
          <e-column field='Retail' headerText='Retail' format='C2' textAlign='Right' width='160'></e-column>
          <e-column field='Total' headerText='Total' format='C2' textAlign='Right' width='160' ></e-column>
        </e-columns>
      </ejs-grid>
    </div>
  </div>
</template>

<script>
import { GridComponent, ColumnDirective, ColumnsDirective, ContextMenu } from '@syncfusion/ej2-vue-grids';
import { salesDatas } from './datasource';
import { GridChart } from '@syncfusion/ej2-grid-chart';

export default {
  components: {
    'ejs-grid': GridComponent,
    'e-column': ColumnDirective,
    'e-columns': ColumnsDirective
  },
  data: () => {
    return {
      data: salesDatas,
      selectionSettings: { type: 'Multiple' },
      contextMenuItems: ['Bar', 'StackingBar', 'StackingBar100', 'Pie',
        'Column', 'StackingColumn', 'StackingColumn100',
        'Line', 'StackingLine', 'StackingLine100',
        'Area', 'StackingArea', 'StackingArea100',
        'Scatter'
      ],
      gridChart: null 
    }
  },
  methods: {
    created() {
      var grid = this.$refs.gridInstance.$el.ej2_instances[0];
      this.gridChart = new GridChart({
        enableRtl: grid.enableRtl,
        locale: grid.locale,
      });
    },
    contextMenuClick(args) {
      if (args.chartType && args.gridInstance) {
        const chartArgs = {
          gridInstance: args.gridInstance,
          chartType: args.chartType,
          records: args.records,
        };
        const chartModel = {
          primaryXAxis: {
            valueType: 'Category',
            labelRotation: 315,
          }
        };
        const model= {
          chart: chartModel,
          accumulationChart: { }
        };
        const categorySeries= {
          category: ['Product', 'Month'],
          series: ['Online', 'Retail']
        };
        this.gridChart.render(chartArgs, model, categorySeries);
      }
    }
  },
  provide: {
    grid: [ContextMenu]
  }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-calendars/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/tailwind.css";
@import '../node_modules/@syncfusion/ej2-grid-chart/styles/tailwind.css';
</style>

Enable export functionality in GridChart

The export functionality in GridChart allows Charts to be saved or shared externally in various formats. This is particularly useful for preserving visualized data or including Charts in reports and presentations.

To enable this feature, set the allowExport property to true when creating the GridChart instance. Once enabled, an export option appears in the Chart popup toolbar, allowing the Chart to be exported in various formats such as PDF, CSV, Print, JPEG, XLSX, SVG, and PNG.

The following code snippet demonstrates how to enable export functionality in GridChart:

gridChart = new GridChart({
  allowExport: true
});

Enable property panel in GridChart

The property panel in GridChart provides a built-in interface to modify Chart settings dynamically at runtime. By default, the property panel is disabled. To enable it, set the enablePropertyPanel option to true during the instantiation of the GridChart object. Here’s how to do it:

gridChart = new GridChart({
  enablePropertyPanel: true
});

When enabled, the property panel appears alongside the Chart popup and offers three main configuration sections:

  • Chart Types: Choose from a variety of Chart types, including Column, Line, Pie, and others.

  • Chart Data: Configure the category axis and series fields for data visualization.

  • Formatting Options: Adjust styling properties such as Chart style, title style, legend appearance, series settings, and axes formatting.

    • Chart Style:

      • Margin : Adjust the margins around the chart (top, bottom, left, right) for better layout spacing.
      • Color: Set distinct colors for different chart elements to improve visual clarity.
    • Title Style

      • Legend - Toggle the visibility of the legend and customize its font, size, color, and position.
      • Series - Enable/disable tooltips and customize Series color and data labels based on categories such as online, retail, or revenue.
    • Axes: - Select axes as either category or value type, and customize:

      • Reverse Order to change the data sequence.
      • Title: Adjust text, font, size, color, and rotation.
      • Label: Modify text, font, size, color, and rotation for better label presentation.

customize the Chart model:

You can customize the Chart by defining a chartModel object in the chart property of the model object within the contextMenuClick event .This allows you to configure various Chart properties such as axes, margins, tooltips, titles, and more. Additionally, you can use the events of the Chart within the chartModel configuration to apply further customizations when the Chart is rendered.

To customize Accumulation Charts (such as Pie), use the accumulationChart property of the model object. This property allows you to configure Chart options like titles, legends, data labels, and visual styles tailored for accumulation-type visualizations. You can also use Accumulation Chart events to apply additional customizations when the Chart is rendered.

The following code snippets demonstrate how to achieve this:

export default {
  methods: {
    contextMenuClick(args) 
    {
      if (args.chartType && args.gridInstance) {
        const chartModel = {
          primaryXAxis: {
            valueType: 'Category',
            labelRotation: 315,
          },
          margin: {
            top: 20,
            bottom: 20,
            right: 20,
            left: 20
          },
          tooltip: {
            enable: true,
            textStyle: {
              size: '16px',
              fontFamily: 'Arial, Helvetica, sans-serif'
            }
          },
          title: 'Sales Data',
          titleStyle: {
            size: '24px',
            fontFamily: 'Arial, Helvetica, sans-serif',
            fontWeight: 'Bold'
          },
          subTitle: 'Sales data for various products over the months',
          load: (args) => {
            if (args.chart.titleStyle) {
              args.chart.titleStyle.color = '#1976d2';
            }
          }
        };
        const accumulationChartModel = {
          title :'Sales Distribution'
        };
        const model= {
          chart: chartModel,
          accumulationChart: accumulationChartModel
        };
      }
    },
  }
}
const contextMenuClick = (args) => {
  if (args.chartType && args.gridInstance) {
    const chartModel = {
      primaryXAxis: {
        valueType: 'Category',
        labelRotation: 315,
      },
      margin: {
        top: 20,
        bottom: 20,
        right: 20,
        left: 20
      },
      tooltip: {
        enable: true,
        textStyle: {
          size: '16px',
          fontFamily: 'Arial, Helvetica, sans-serif'
        }
      },
      title: 'Sales Data',
      titleStyle: {
        size: '24px',
        fontFamily: 'Arial, Helvetica, sans-serif',
        fontWeight: 'Bold'
      },
      subTitle: 'Sales data for various products over the months',
      load: (args) => {
        if (args.chart.titleStyle) {
          args.chart.titleStyle.color = '#1976d2';
        }
      }
    };
    const accumulationChartModel = {
      title :'Sales Distribution'
    };
    const model= {
      chart: chartModel,
      accumulationChart: accumulationChartModel
    };
  }
}

You can also programmatically update the Chart’s appearance using the updateChartSettings(args: UpdateChartArgs) event provided by the GridChart integration. This event is triggered when you modify Chart properties through the Chart popup’s property panel. This is useful for applying custom themes, adjusting axis settings, or modifying series styles.

The following code snippet demonstrates how to dynamically customize chart margins and restrict their values to a minimum of 20 using the updateChartSettings event.

export default {
  methods: {
    created() {
      var grid = this.$refs.gridInstance.$el.ej2_instances[0];
      this.gridChart = new GridChart({
        enablePropertyPanel: true,
        allowExport: true,
        enableRtl: grid.enableRtl,
        locale: grid.locale,
        updateChartSettings: this.updateChartSettings
      });
    },
    updateChartSettings(args) {
      const chart = args.changes?.chart;
      if (!chart) return;
      const chartMargin = chart.margin;

      // Restrict margin values to minimum 20.
      if (chartMargin && !isNullOrUndefined(chartMargin)) {
        if ((chartMargin.top ?? 0) < 20) chartMargin.top = 20;
        if ((chartMargin.bottom ?? 0) < 20) chartMargin.bottom = 20;
        if ((chartMargin.left ?? 0) < 20) chartMargin.left = 20;
        if ((chartMargin.right ?? 0) < 20) chartMargin.right = 20;
      }
    },
  }
}
const created = () => {
  gridChart.value = new GridChart({
    enablePropertyPanel: true,
    allowExport: true,
    enableRtl: gridInstance.value.enableRtl,
    locale: gridInstance.value.locale,
    updateChartSettings: updateChartSettings
  });
};

const updateChartSettings = (args) => {
  const chart = args.changes.chart;
  if (!chart) return;

  // Restrict margin values to minimum 20.
  const chartMargin = chart.margin;
  if (chartMargin && !isNullOrUndefined(chartMargin)) {
    if (chartMargin.top < 20) chartMargin.top = 20;
    if (chartMargin.bottom < 20) chartMargin.bottom = 20;
    if (chartMargin.left < 20) chartMargin.left = 20;
    if (chartMargin.right < 20) chartMargin.right = 20;
  }
};

The following complete example demonstrates how to enable the property panel by setting enablePropertyPanel to true, customize the chart using the chartModel within contextMenuClick event, and dynamically control or customize the behavior of the updateChartSettings event.

<template>
  <div class="col-lg-12 control-section">
    <div class="content-wrapper">
      <ejs-grid ref='gridInstance' id='GridChart' :dataSource='data' :height="417" :allowSelection="true" :selectionSettings="selectionSettings"
      :contextMenuItems="contextMenuItems" :contextMenuClick="contextMenuClick" :created="created">
        <e-columns>
          <e-column type='checkbox' width='50'></e-column>
          <e-column field='Product' headerText='Products' width='200' ></e-column>
          <e-column field='Month' headerText='Month' width='140' ></e-column>
          <e-column field='Online' headerText='Online' format='C2' textAlign='Right' width='160'></e-column>
          <e-column field='Retail' headerText='Retail' format='C2' textAlign='Right' width='160'></e-column>
          <e-column field='Total' headerText='Total' format='C2' textAlign='Right' width='160' ></e-column>
        </e-columns>
      </ejs-grid>
    </div>
  </div>
</template>

<script setup>
import { GridComponent as EjsGrid, ColumnDirective as EColumn, ColumnsDirective as EColumns, ContextMenu } from "@syncfusion/ej2-vue-grids";
import { salesDatas } from "./datasource.js";
import { provide, ref } from "vue";
import { GridChart } from '@syncfusion/ej2-grid-chart';
import { isNullOrUndefined } from "@syncfusion/ej2-base";

const gridInstance=ref(null);
const data = salesDatas;
const selectionSettings = { type: 'Multiple' };
const contextMenuItems = ['Bar', 'StackingBar', 'StackingBar100', 'Pie',
  'Column', 'StackingColumn', 'StackingColumn100',
  'Line', 'StackingLine', 'StackingLine100',
  'Area', 'StackingArea', 'StackingArea100',
  'Scatter'
];
let gridChart = ref(null);

const created = () => {
  gridChart.value = new GridChart({
    enablePropertyPanel: true,
    allowExport: true,
    enableRtl: gridInstance.value.enableRtl,
    locale: gridInstance.value.locale,
    updateChartSettings: updateChartSettings
  });
};

const contextMenuClick = (args) => {
  if (args.chartType && args.gridInstance) {
    const chartArgs = {
      gridInstance: args.gridInstance,
      chartType: args.chartType,
      records: args.records,
    };
    const chartModel = {
      primaryXAxis: {
        valueType: 'Category',
        labelRotation: 315,
      },
      margin: {
        top: 20,
        bottom: 20,
        right: 20,
        left: 20
      },
      tooltip: {
        enable: true,
        textStyle: {
          size: '16px',
          fontFamily: 'Arial, Helvetica, sans-serif'
        }
      },
      title: 'Sales Data',
      titleStyle: {
        size: '24px',
        fontFamily: 'Arial, Helvetica, sans-serif',
        fontWeight: 'Bold'
      },
      subTitle: 'Sales data for various products over the months',
      load: (args) => {
        if (args.chart.titleStyle) {
          args.chart.titleStyle.color = '#1976d2';
        }
      }
    };
    const accumulationChartModel = {
      title :'Sales Distribution'
    };
    const model= {
      chart: chartModel,
      accumulationChart: accumulationChartModel
    };
    const categorySeries= {
      category: ['Product', 'Month'],
      series: ['Online', 'Retail']
    };
    gridChart.value.render(chartArgs, model, categorySeries);
  }
};

const updateChartSettings = (args) => {
  const chart = args.changes?.chart;
  if (!chart) return;
  const chartMargin = chart.margin;
  if (chartMargin && !isNullOrUndefined(chartMargin)) {
    if (chartMargin.top < 20) chartMargin.top = 20;
    if (chartMargin.bottom < 20) chartMargin.bottom = 20;
    if (chartMargin.left < 20) chartMargin.left = 20;
    if (chartMargin.right < 20) chartMargin.right = 20;
  }
};

provide('grid', [ContextMenu]);
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-calendars/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/tailwind.css";
@import '../node_modules/@syncfusion/ej2-grid-chart/styles/tailwind.css';
</style>
<template>
  <div class="col-lg-12 control-section">
    <div class="content-wrapper">
      <ejs-grid ref='gridInstance' id='GridChart' :dataSource='data' :height="417" :allowSelection="true" :selectionSettings="selectionSettings"
      :contextMenuItems="contextMenuItems" :contextMenuClick="contextMenuClick" :created="created">
        <e-columns>
          <e-column type='checkbox' width='50'></e-column>
          <e-column field='Product' headerText='Products' width='200' ></e-column>
          <e-column field='Month' headerText='Month' width='140' ></e-column>
          <e-column field='Online' headerText='Online' format='C2' textAlign='Right' width='160'></e-column>
          <e-column field='Retail' headerText='Retail' format='C2' textAlign='Right' width='160'></e-column>
          <e-column field='Total' headerText='Total' format='C2' textAlign='Right' width='160' ></e-column>
        </e-columns>
      </ejs-grid>
    </div>
  </div>
</template>

<script>
import { GridComponent, ColumnDirective, ColumnsDirective, ContextMenu } from '@syncfusion/ej2-vue-grids';
import { salesDatas } from './datasource';
import { GridChart } from '@syncfusion/ej2-grid-chart';
import { isNullOrUndefined } from "@syncfusion/ej2-base";

export default {
  components: {
    'ejs-grid': GridComponent,
    'e-column': ColumnDirective,
    'e-columns': ColumnsDirective
  },
  data: () => {
    return {
      data: salesDatas,
      selectionSettings: { type: 'Multiple' },
      contextMenuItems: ['Bar', 'StackingBar', 'StackingBar100', 'Pie',
        'Column', 'StackingColumn', 'StackingColumn100',
        'Line', 'StackingLine', 'StackingLine100',
        'Area', 'StackingArea', 'StackingArea100',
        'Scatter'
      ],
      gridChart: null 
    }
  },
  methods: {
    created() {
      var grid = this.$refs.gridInstance.$el.ej2_instances[0];
      this.gridChart = new GridChart({
        enablePropertyPanel: true,
        allowExport: true,
        enableRtl: grid.enableRtl,
        locale: grid.locale,
        updateChartSettings: this.updateChartSettings
      });
    },
    contextMenuClick(args) {
      if (args.chartType && args.gridInstance) {
        const chartArgs = {
          gridInstance: args.gridInstance,
          chartType: args.chartType,
          records: args.records,
        };
        const chartModel = {
          primaryXAxis: {
            valueType: 'Category',
            labelRotation: 315,
          },
          margin: {
            top: 20,
            bottom: 20,
            right: 20,
            left: 20
          },
          tooltip: {
            enable: true,
            textStyle: {
              size: '16px',
              fontFamily: 'Arial, Helvetica, sans-serif'
            }
          },
          title: 'Sales Data',
          titleStyle: {
            size: '24px',
            fontFamily: 'Arial, Helvetica, sans-serif',
            fontWeight: 'Bold'
          },
          subTitle: 'Sales data for various products over the months',
          load: (args) => {
            if (args.chart.titleStyle) {
              args.chart.titleStyle.color = '#1976d2';
            }
          }
        };
        const accumulationChartModel = {
          title :'Sales Distribution'
        };
        const model= {
          chart: chartModel,
          accumulationChart: accumulationChartModel
        };
        const categorySeries= {
          category: ['Product', 'Month'],
          series: ['Online', 'Retail']
        };
        this.gridChart.render(chartArgs, model, categorySeries);
      }
    },
    updateChartSettings(args) {
      const chart = args.changes?.chart;
      if (!chart) return;
      const chartMargin = chart.margin;
      if (chartMargin && !isNullOrUndefined(chartMargin)) {
        if (chartMargin.top < 20) chartMargin.top = 20;
        if (chartMargin.bottom < 20) chartMargin.bottom = 20;
        if (chartMargin.left < 20) chartMargin.left = 20;
        if (chartMargin.right < 20) chartMargin.right = 20;
      }
    },
  },
  provide: {
    grid: [ContextMenu]
  }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-calendars/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind.css";
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/tailwind.css";
@import '../node_modules/@syncfusion/ej2-grid-chart/styles/tailwind.css';
</style>

Syncfusion AI Assistant

How can I help you?

Integrate Chart in Syncfusion Angular Grid

11 Jun 202624 minutes to read

Grid and Chart integration in Syncfusion® enables visualizing tabular data by linking the grid with a chart. Selected data can be rendered interactively as bar, line, or pie charts via the ContextMenu feature. This integration is suitable for dashboards, reporting tools, and other data-driven applications where tabular and visual representations improve analysis and decision making.

Steps for Chart integration

Refer to the sections below to configure and enable chart integration in the Grid.

Required dependencies

Below is the list of minimum dependencies required to integrate chart functionality into the grid:

|-- dependencies
  |-- @syncfusion/ej2-grid-chart
    |--@syncfusion/ej2-angular-grids
    |-- @syncfusion/ej2-base
    |-- @syncfusion/ej2-buttons
    |-- @syncfusion/ej2-dropdowns
    |-- @syncfusion/ej2-grids
    |-- @syncfusion/ej2-inputs
    |-- @syncfusion/ej2-navigations
    |-- @syncfusion/ej2-popups
    |-- @syncfusion/ej2-splitbuttons
    |-- @syncfusion/ej2-notifications
    |-- @syncfusion/ej2-calendars
    |-- @syncfusion/ej2-charts

Setup Angular environment

Use Angular CLI to setup Angular applications. Install Angular CLI using the following command:

npm install -g @angular/cli

Create an Angular application

Start a new Angular application using the Angular CLI command:

ng new my-app

This command will prompt for project settings such as Angular routing and stylesheet format preferences.

Initial_setup

By default, it creates a CSS-based application.

Navigate to the created project folder:

cd my-app

Add Syncfusion Angular packages

All Essential JS 2 packages are published in the npmjs.com registry.

Install the Grid-Chart package using the following command:

npm install @syncfusion/ej2-grid-chart --save

Import Syncfusion CSS styles

Syncfusion Angular controls include built-in themes available in installed packages. Apply themes by importing required CSS files from the node_modules directory.

To use the “Material” theme, add the following imports to the src/styles.css file:

@import '../node_modules/@syncfusion/ej2-base/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-calendars/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-notifications/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-angular-grids/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-grid-chart/styles/material3.css';

Chart integration via context menu in Grid

This section explains grid rendering of charts dynamically based on interactions within the Angular Data Grid using the context menu. Right-clicking on selected rows presents chart types such as bar, pie, or line for immediate visualization. This enhances interactivity and provides a quick analytical view.

For example, in a sales dashboard, selecting records for specific products can display a comparative bar or pie chart that shows online sales versus retail sales or revenue trends across months.

Implementation steps

Step 1: Inject required modules

Import necessary modules from Grid, Chart, and GridChart packages, and inject the ContextMenuService to enable context menu functionality:

import { ContextMenuClickEventArgs, ContextMenuService, GridModule, ContextMenuItem, GridComponent} from '@syncfusion/ej2-angular-grids';
import { CategorySeries, ChartChanges, ChartPopupArgs, GridChart } from '@syncfusion/ej2-grid-chart';
import { ChartModel } from '@syncfusion/ej2-charts';

@Component({
  imports: [ GridModule],
  providers: [ContextMenuService],
  standalone: true,
  selector: 'app-root',
  templateUrl: 'app.component.html',
})

Step 2: Define Chart options in Grid context menu

Add chart visualization options as context menu items within the grid configuration using the contextMenuItems property. These items allow right-clicking on selected rows to choose a chart type for visualization.

export class AppComponent implements OnInit {
  public contextMenuItems?: ContextMenuItem[];

  ngOnInit(): void {
    this.contextMenuItems = [ 'Bar', 'StackingBar', 'StackingBar100', 'Pie', 'Column', 'StackingColumn', 'StackingColumn100', 'Line', 'StackingLine', 'StackingLine100', 'Area', 'StackingArea', 'StackingArea100', 'Scatter'];
  }
}

Step 3: Initialize GridChart instance on Grid creation

Inside the grid’s created event, instantiate a GridChart object. This instance is used to render charts dynamically based on the selected grid data.

created(): void {
  this.gridChart = new GridChart({
    enableRtl: (this.grid as GridComponent).enableRtl,
    locale: (this.grid as GridComponent).locale,
  });
}

This ensures chart instance readiness for seamless context menu interaction.

Step 4: Handle context menu click to render Chart

Use the contextMenuClick event to determine the selected chart type and render it with the gridChart.render method.

The ContextMenuClick event provides the following arguments:

  • args.chartType: Selected chart type.
  • args.gridInstance: Current grid instance.
  • args.records: Selected data records to visualize.

The gridChart.render method accepts three arguments:

  • chartArgs: Contains the grid instance, chart type, and the selected records.

  • chartModel: Specifies chart configuration, including axes, labels, legends, tooltips, and other appearance or behavior settings. See Syncfusion’s Chart Model for details.

  • categorySeries: Specifies data fields for categories and series.

    • Category fields define the grouping axis.
    • Series fields define the values plotted on the chart.
contextMenuClick(args: ContextMenuClickEventArgs) {
  if (args.chartType) {
    // Prepare Chart arguments
    const chartArgs: ChartPopupArgs = {
      gridInstance: (args.gridInstance as GridComponent),
      chartType: args.chartType,
      records: args.records as SalesRecord[],
    };

    // Configure Chart model
    const chartModel: ChartModel = {
      primaryXAxis: {
        valueType: 'Category',
        labelRotation: 315
      }
    };

    // Combine Chart models
    const model: ChartChanges = { chart: chartModel, accumulationChart: {} };

    // Define category and series fields
    const categorySeries: CategorySeries = {
      category: ['Product', 'Month'],
      series: ['Online', 'Retail']
    };

    // Render Chart
    (this.gridChart as GridChart).render(chartArgs, model, categorySeries);
  }
}

The following complete example demonstrates chart integration into grid context menu:

import { salesDatas } from './datasource';
import { Component, OnInit, ViewChild } from '@angular/core';
import { ContextMenuClickEventArgs, ContextMenuItem, ContextMenuService, GridComponent, GridModule, IGrid } from '@syncfusion/ej2-angular-grids';
import { ChartModel } from '@syncfusion/ej2-charts';
import { CategorySeries, ChartChanges, ChartPopupArgs, GridChart } from '@syncfusion/ej2-grid-chart';

@Component({
  imports: [ GridModule],
  providers: [ContextMenuService],
  standalone: true,
  selector: 'app-root',
  templateUrl: 'app.component.html',
})

export class AppComponent implements OnInit {
  @ViewChild('grid') public grid?: GridComponent;
  public data?: Object[];
  public gridChart?: GridChart;
  public contextMenuItems?: ContextMenuItem[];
  public selectionSettings?: Object;

  ngOnInit(): void {
    this.data = salesDatas;
    this.selectionSettings = { type: 'Multiple' };
    this.contextMenuItems= [ 'Bar', 'StackingBar', 'StackingBar100', 'Pie', 'Column', 'StackingColumn', 'StackingColumn100', 'Line', 'StackingLine', 'StackingLine100', 'Area', 'StackingArea', 'StackingArea100', 'Scatter'];
  }

  created(): void {
    this.gridChart = new GridChart({
      enableRtl: (this.grid as GridComponent).enableRtl,
      locale: (this.grid as GridComponent).locale,
    });
  }

  contextMenuClick(args: ContextMenuClickEventArgs) {
    if (args.chartType) {
      const chartArgs: ChartPopupArgs = {
        gridInstance: (args.gridInstance as IGrid),
        chartType: args.chartType,
        records: args.records as SalesRecord[],
      };
      const chartModel: ChartModel = {
        primaryXAxis: {
          valueType: 'Category',
          labelRotation: 315
        }
      };

      const model: ChartChanges = { chart: chartModel, accumulationChart: {} };
      const categorySeries: CategorySeries = {
        category: ['Product', 'Month'],
        series: ['Online', 'Retail']
      };
      (this.gridChart as GridChart).render(chartArgs, model, categorySeries);
    }
  }
}

interface SalesRecord {
  Product: string;
  Category: string;
  Year: number;
  Online: number;
  Retail: number;
  ProfitLoss: number;
  UnitsSold: number;
  Revenue: number;
  Image: string;
  CategoryIcon: string;
}
<ejs-grid [dataSource]='data' #grid id="GridChart" height="500" allowSelection="true" [selectionSettings]='selectionSettings' [contextMenuItems]='contextMenuItems' (contextMenuClick)='contextMenuClick($event)' (created)='created()'>
  <e-columns>
    <e-column type='checkbox' width='50'></e-column>
    <e-column field='Product' headerText='Product' width='200'></e-column>
    <e-column field='Month' headerText='Month' width='140'></e-column>
    <e-column field='Online' headerText='Online' format='C2' textAlign='Right' width='160'></e-column>
    <e-column field='Total' headerText='Total' format='C2' textAlign='Right' width='160'></e-column>
  </e-columns>
</ejs-grid>
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Enable export functionality in GridChart

GridChart export functionality enables saving or sharing charts in multiple formats. This is useful for preserving visualizations or including charts in reports and presentations.

Enable export by setting the allowExport property to true when creating the GridChart instance. Once enabled, an export option appears in the chart popup toolbar, allowing export to formats such as PDF, CSV, Print, JPEG, XLSX, SVG, and PNG.

gridChart = new GridChart({
  allowExport: true
});

When enabled, the property panel appears alongside chart popups and offers three main configuration sections:

Chart types: Choose from a variety of chart types, including Column, Line, Pie, and others.

Chart data: Configure category axis and series fields for data visualization.

Formatting options: Adjust styling properties such as chart style, title style, legend appearance, series settings, and axes formatting.

  • Chart style:

    • Margin: Adjust margins around charts (top, bottom, left, right) for better layout spacing.
    • Color: Set distinct colors for different chart elements to improve visual clarity.
  • Title style:

    • Legend: Toggle legend visibility and customize font, size, color, and position.
    • Series: Enable/disable tooltips and customize Series colors and data labels based on categories.
  • Axes: Select axes as category or value type, and customize:

    • Reverse Order to change data sequence.
    • Title: Adjust text, font, size, color, and rotation.
    • Label: Modify text, font, size, color, and rotation for better presentation.

Customize Chart models

Accumulation Charts (for example, pie charts) can be customized using the accumulationChart property of the model object. This property configures titles, legends, data labels, and visual styles for accumulation-type visualizations.

Additionally, Accumulation chart events can be used to apply extra customizations during rendering.

The following code demonstrates chart customization:

contextMenuClick(args: ContextMenuClickEventArgs) {
  if (args.chartType) {
    const chartArgs: ChartPopupArgs = {
      gridInstance: (args.gridInstance as GridComponent),
      chartType: args.chartType,
      records: (args.records as SalesRecord[]),
    };
    const chartModel: ChartModel = {
      primaryXAxis: {
        valueType: 'Category',
        labelRotation: 315,
      },
      margin: {
        top: 20,
        bottom: 20,
        right: 20,
        left: 20
      },
      tooltip: {
        enable: true,
        textStyle: {
          size: '16px',
          fontFamily: 'Arial, Helvetica, sans-serif'
        }
      },
      title: 'Sales Data',
      titleStyle: {
        size: '24px',
        fontFamily: 'Arial, Helvetica, sans-serif',
        fontWeight: 'Bold'
      },
      subTitle: 'Sales data for various products over the months',
      load: (args: ILoadedEventArgs) => {
        if (args.chart.titleStyle) {
            args.chart.titleStyle.color = '#1976d2';
        }
      }
    };
    const accumulationChartModel: AccumulationChartModel = {
      title: 'Sales Distribution'
    }

    // Combine Chart models
    const model: ChartChanges = {
      chart: chartModel,
      accumulationChart: accumulationChartModel
    };
  }
}

Chart appearance can also be updated programmatically using the updateChartSettings event provided by the GridChart integration. This event triggers when chart properties are modified through the chart popup’s property panel. The event enables applying custom themes, adjusting axis settings, or modifying series styles.

The following code snippet demonstrates dynamically customizing chart margins and restricting their values to a minimum of “20” using the updateChartSettings event:

created(): void {
  this.gridChart = new GridChart({
    enablePropertyPanel: true,
    allowExport: true,
    enableRtl: (this.grid as GridComponent).enableRtl,
    locale: (this.grid as GridComponent).locale,
    updateChartSettings: this.updateChartSettings.bind(this),
  });
}

updateChartSettings(args: UpdateChartArgs){
  const chart = args.changes?.chart;
  if (!chart) return;

  // Restrict margin values to minimum 20
  const chartMargin = chart.margin;
  if (chartMargin && !isNullOrUndefined(chartMargin)) {
    if ((chartMargin.top ?? 0) < 20) chartMargin.top = 20;
    if ((chartMargin.bottom ?? 0) < 20) chartMargin.bottom = 20;
    if ((chartMargin.left ?? 0) < 20) chartMargin.left = 20;
    if ((chartMargin.right ?? 0) < 20) chartMargin.right = 20;
  }
}

The following example demonstrates enabling the property panel by setting enablePropertyPanel to true, customizing the chart using the chartModel within contextMenuClick event, and dynamically controlling or customizing the behavior of the updateChartSettings event.

import { salesDatas } from './datasource';
import { Component, OnInit, ViewChild } from '@angular/core';
import { ContextMenuClickEventArgs, ContextMenuItem, ContextMenuService, GridComponent, GridModule, IGrid } from '@syncfusion/ej2-angular-grids';
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { AccumulationChartModel, ChartModel, ILoadedEventArgs } from '@syncfusion/ej2-charts';
import { CategorySeries, ChartChanges, ChartPopupArgs, GridChart, UpdateChartArgs } from '@syncfusion/ej2-grid-chart';

@Component({
  imports: [ GridModule],
  providers: [ContextMenuService],
  standalone: true,
  selector: 'app-root',
  templateUrl: 'app.component.html',
})

export class AppComponent implements OnInit {
  @ViewChild('grid') public grid?: GridComponent;
  public data?: Object[];
  public gridChart?: GridChart;
  public contextMenuItems?: ContextMenuItem[];
  public selectionSettings?: Object;

  ngOnInit(): void {
    this.data = salesDatas;
    this.selectionSettings = { type: 'Multiple' };
    this.contextMenuItems= [ 'Bar', 'StackingBar', 'StackingBar100', 'Pie', 'Column', 'StackingColumn', 'StackingColumn100', 'Line', 'StackingLine', 'StackingLine100', 'Area', 'StackingArea', 'StackingArea100', 'Scatter'];
  }

  created(): void {
    this.gridChart = new GridChart({
      enablePropertyPanel: true,
      allowExport: true,
      enableRtl: (this.grid as GridComponent).enableRtl,
      locale: (this.grid as GridComponent).locale,
      updateChartSettings: this.updateChartSettings.bind(this),
    });
  }

  contextMenuClick(args: ContextMenuClickEventArgs) {
    if (args.chartType) {
      const chartArgs: ChartPopupArgs = {
        gridInstance: (args.gridInstance as IGrid),
        chartType: args.chartType,
        records: (args.records as SalesRecord[]),
      };
      const chartModel: ChartModel = {
        primaryXAxis: {
          valueType: 'Category',
          labelRotation: 315,
        },
        margin: {
          top: 20,
          bottom: 20,
          right: 20,
          left: 20
        },
        tooltip: {
          enable: true,
          textStyle: {
            size: '16px',
            fontFamily: 'Arial, Helvetica, sans-serif'
          }
        },
        title: 'Sales Data',
        titleStyle: {
          size: '24px',
          fontFamily: 'Arial, Helvetica, sans-serif',
          fontWeight: 'Bold'
        },
        subTitle: 'Sales data for various products over the months',
        load: (args: ILoadedEventArgs) => {
          if (args.chart.titleStyle) {
            args.chart.titleStyle.color = '#1976d2';
          }
        }
      };
      const accumulationChartModel: AccumulationChartModel = {
        title :'Sales Distribution'
      }
      const model: ChartChanges = {
        chart: chartModel,
        accumulationChart: accumulationChartModel
      };
      const categorySeries: CategorySeries = {
        category: ['Product', 'Month'],
        series: ['Online', 'Retail']
      };
      (this.gridChart as GridChart).render(chartArgs, model, categorySeries);
    }
  }

  updateChartSettings(args: UpdateChartArgs){
    const chart = args.changes?.chart;
    if (!chart) return;

    const chartMargin = chart.margin;
    if (chartMargin && !isNullOrUndefined(chartMargin)) {
      if ((chartMargin.top ?? 0) < 20) chartMargin.top = 20;
      if ((chartMargin.bottom ?? 0) < 20) chartMargin.bottom = 20;
      if ((chartMargin.left ?? 0) < 20) chartMargin.left = 20;
      if ((chartMargin.right ?? 0) < 20) chartMargin.right = 20;
    }
  }
}

interface SalesRecord {
  Product: string;
  Category: string;
  Year: number;
  Online: number;
  Retail: number;
  ProfitLoss: number;
  UnitsSold: number;
  Revenue: number;
  Image: string;
  CategoryIcon: string;
}
<ejs-grid [dataSource]='data' #grid id="GridChart" height="500" allowSelection="true" [selectionSettings]='selectionSettings' [contextMenuItems]='contextMenuItems' (contextMenuClick)='contextMenuClick($event)' (created)='created()'>
  <e-columns>
    <e-column type='checkbox' width='50'></e-column>
    <e-column field='Product' headerText='Product' width='200'></e-column>
    <e-column field='Month' headerText='Month' width='140'></e-column>
    <e-column field='Online' headerText='Online' format='C2' textAlign='Right' width='160'></e-column>
    <e-column field='Total' headerText='Total' format='C2' textAlign='Right' width='160'></e-column>
  </e-columns>
</ejs-grid>
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Syncfusion AI Assistant

How can I help you?

Integrate Chart in Syncfusion React Grid

17 Feb 202624 minutes to read

Grid and Chart integration in Syncfusion® enables visualizing tabular data by linking the grid with a chart. Selected data can be rendered interactively as bar, line, or pie charts via the ContextMenu feature. This integration is suitable for dashboards, reporting tools, and other data-driven applications where tabular and visual representations improve analysis and decision making.

Steps for chart integration

Follow these steps to integrate charts into the grid:

Dependencies

Below is the list of minimum dependencies required to integrate chart functionality into the grid:

|-- dependencies
  |-- @syncfusion/ej2-grid-chart
    |-- @syncfusion/ej2-buttons
    |-- @syncfusion/ej2-dropdowns
    |-- @syncfusion/ej2-grids
    |-- @syncfusion/ej2-inputs
    |-- @syncfusion/ej2-navigations
    |-- @syncfusion/ej2-popups
    |-- @syncfusion/ej2-splitbuttons
    |-- @syncfusion/ej2-notifications
    |-- @syncfusion/ej2-calendars
    |-- @syncfusion/ej2-charts

Setup for local development

Choose one of the following options to set up a React application. The recommended approach is using create-react-app, which prepares a development environment and optimizes the application for production. Refer to the installation instructions.

npx create-react-app my-app
cd my-app
npm start

or

yarn create react-app my-app
cd my-app
yarn start

Run the following command to create a React application in a TypeScript environment:

npx create-react-app my-app --template typescript
cd my-app
npm start

Alternatively, create an application with npm init. For npm init, ensure npm is version 6 or higher.

npm init react-app my-app
cd my-app
npm start

Add Syncfusion React packages

Syncfusion® React component packages are available at npmjs.com. Install the corresponding npm packages to use Syncfusion® React components in a project.

Run the following commands to install the grid and grid-chart packages.

npm install @syncfusion/ej2-react-grids
npm install @syncfusion/ej2-grid-chart

Import the Syncfusion CSS styles

Syncfusion® React controls include built-in themes provided in the installed packages. Apply one of the built-in themes to match the application’s visual style.

Import the required CSS files from the node_modules directory. For example, to use the “Material 3” theme, add the following imports to the src/App.css file.

@import '../node_modules/@syncfusion/ej2-base/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-calendars/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-notifications/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-react-grids/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-grid-chart/styles/material3.css';

Chart integration via context menu in grid

This section explains how the grid can render charts dynamically based on interactions within the Syncfusion® React grid using the context menu. Right-clicking on selected rows presents chart types such as bar, pie, or line for immediate visualization. This enhances interactivity and provides a quick analytical view.

For example, in a sales dashboard, selecting records for specific products can display a comparative bar or pie chart that shows online sales versus retail sales or revenue trends across months.

Steps to integrate a chart into the grid via the context menu:

Step 1. Inject required modules:

Import the required modules from the Grid, GridChart, and Chart packages, then inject the ContextMenu module into the grid:

import { ColumnDirective, ColumnsDirective, ContextMenuClickEventArgs, ContextMenu, GridComponent, Inject } from '@syncfusion/ej2-react-grids';
import { GridChart } from '@syncfusion/ej2-grid-chart';

function App() {
  return (
    <div>
      <GridComponent>
        <ColumnsDirective>
        </ColumnsDirective>
        <Inject services={[ContextMenu]} />
      </GridComponent>
    </div>
  );
}

export default App;
import { ColumnDirective, ColumnsDirective, ContextMenuClickEventArgs, ContextMenu, GridComponent, Inject, SelectionSettingsModel} from '@syncfusion/ej2-react-grids';
import { GridChart, CategorySeries, ChartChanges} from '@syncfusion/ej2-grid-chart';
import { ChartModel } from '@syncfusion/ej2-charts';

function App() {
  return (
    <div>
      <GridComponent>
        <ColumnsDirective>
        </ColumnsDirective>
        <Inject services={[ContextMenu]} />
      </GridComponent>
    </div>
  );
}

export default App;

Step 2: Define chart options to grid context menu:

Add chart visualization options as context menu items within the grid configuration using the contextMenuItems property. These items allow right-clicking on selected rows to choose a chart type for visualization.

contextMenuItems={[
  'Bar', 'StackingBar', 'StackingBar100',
  'Pie', 'Column', 'StackingColumn', 'StackingColumn100',
  'Line', 'StackingLine', 'StackingLine100',
  'Area', 'StackingArea', 'StackingArea100', 'Scatter'
]}

Step 3: Initialize GridChart instance on grid creation:

Inside the grid’s created event, instantiate a GridChart object. This instance is used to render charts dynamically based on the selected grid data.

function created() {
  gridChart = new GridChart({
    enableRtl: grid.enableRtl,
    locale: grid.locale,
  });
}
function created() {
  gridChart = new GridChart({
    enableRtl: (grid as GridComponent).enableRtl,
    locale: (grid as GridComponent).locale,
  });
}

This ensures the chart instance is ready when the grid initializes, allowing seamless interaction through the context menu.

Step 4: Handle context menu click to render chart:

Use the contextMenuClick event to determine the selected chart type and render it with the gridChart.render method.

The contextMenuClick event provides the following arguments:

  • args.chartType: Selected chart type.
  • args.gridInstance: Current grid instance.
  • args.records: Selected data records to visualize.

The gridChart.render method accepts three arguments:

  • chartArgs: Contains the grid instance, chart type, and the selected records.

  • chartModel: Specifies chart configuration, including axes, labels, legends, tooltips, and other appearance or behavior settings. See Syncfusion’s Chart Model for details.

  • categorySeries: Specifies data fields for categories and series.

    • Category fields define the grouping axis.
    • Series fields define the values plotted on the chart.
function contextMenuClick(args) 
{
  if (args.chartType) 
  {
    // Prepare the chart arguments including the grid instance, chart type, and records to plot.
    const chartArgs = {
      gridInstance: args.gridInstance,
      chartType: args.chartType,
      records: args.records
    };

    // Set up the Chart model configurations.
    const chartModel = {
      primaryXAxis: {
        valueType: 'Category',
        labelRotation: 315
      }
    };

    // Combine both Chart models into a single model for rendering.
    const model = {
      chart: chartModel,
      accumulationChart: {}
    };

    // Determine fields for category and series data in the Chart.
    const categorySeries = {
      category: ['Product', 'Month'],
      series: ['Online', 'Retail']
    };

    // Render the chart using the configured arguments and models.
    // The render function uses the defined chartArgs, model, and categorySeries to display the chart.
    gridChart.render(chartArgs, model, categorySeries);
  }
}
function contextMenuClick(args: ContextMenuClickEventArgs) 
{
  if (args.chartType) 
  {
    const chartArgs = {
      gridInstance: (args.gridInstance as GridComponent),
      chartType: args.chartType,
      records: (args.records as SalesRecord[])
    };

    // Set up the chart model configurations.
    const chartModel: ChartModel = {
      primaryXAxis: {
        valueType: 'Category',
        labelRotation: 315
      }
    };

    // Combine both chart models into a single model for rendering.
    const model: ChartChanges = {
      chart: chartModel,
      accumulationChart: {}
    };

    // Determine fields for category and series data in the chart.
    const categorySeries: CategorySeries = {
      category: ['Product', 'Month'],
      series: ['Online', 'Retail']
    };

    // Render the chart using the configured arguments and models.
    // The render function uses the defined chartArgs, model, and categorySeries to display the chart.
    (gridChart as GridChart).render(chartArgs, model, categorySeries);
  }
}

The following example demonstrates integrating charts into the grid context menu by using the contextMenuClick event and the gridChart.render method:

import { ColumnDirective, ColumnsDirective, ContextMenu, GridComponent, Inject } from '@syncfusion/ej2-react-grids';
import { GridChart } from '@syncfusion/ej2-grid-chart';
import * as React from 'react';
import { salesDatas } from './datasource';

function App() {
  let grid;
  let gridChart;
  const selectionSettings = { type: 'Multiple' };

  function created() {
    gridChart = new GridChart({
      enableRtl: grid.enableRtl,
      locale: grid.locale,
    });
  }

  function contextMenuClick(args) {
    if (args.chartType) {
      const chartArgs = {
        gridInstance: args.gridInstance,
        chartType: args.chartType,
        records: args.records
      };
      const chartModel = {
        primaryXAxis: {
          valueType: 'Category',
          labelRotation: 315
        }
      };
      const model = {
        chart: chartModel,
        accumulationChart: {}
      };
      const categorySeries = {
        category: ['Product', 'Month'],
        series: ['Online', 'Retail']
      };
      gridChart.render(chartArgs, model, categorySeries);
    }
  }

  return (
    <div>
      <GridComponent
        dataSource={salesDatas}
        height={340}
        ref={g => (grid = g)}
        created={created}
        contextMenuClick={contextMenuClick}
        allowSelection={true}
        contextMenuItems={[
          'Bar', 'StackingBar', 'StackingBar100',
          'Pie', 'Column', 'StackingColumn', 'StackingColumn100',
          'Line', 'StackingLine', 'StackingLine100',
          'Area', 'StackingArea', 'StackingArea100', 'Scatter'
        ]}
        selectionSettings={selectionSettings}
      >
        <ColumnsDirective>
          <ColumnDirective type="checkbox" width="50" />
          <ColumnDirective field="Product" headerText="Product" width="90" />
          <ColumnDirective field="Month" headerText="Month" width="180" />
          <ColumnDirective field="Online" headerText="Online" width="120" textAlign="Right" />
          <ColumnDirective field="Retail" headerText="Retail" width="110" textAlign="Right" />
          <ColumnDirective field="Total" headerText="Total" width="110" textAlign="Right" />
        </ColumnsDirective>
        <Inject services={[ContextMenu]} />
      </GridComponent>
    </div>
  );
}

export default App;
import { ColumnDirective, ColumnsDirective, ContextMenuClickEventArgs, ContextMenu, GridComponent, Inject , SelectionSettingsModel } from '@syncfusion/ej2-react-grids';
import { GridChart, CategorySeries, ChartChanges} from '@syncfusion/ej2-grid-chart';
import { ChartModel } from '@syncfusion/ej2-charts';
import * as React from 'react';
import { salesDatas } from './datasource';

interface SalesRecord {
  Product: string;
  Month: string;
  Online: number;
  Retail: number;
  Total: number;
}

function App() {
  let grid: GridComponent | null;
  let gridChart: GridChart;
  const selectionSettings: SelectionSettingsModel = { type: 'Multiple' };

  function created() {
    gridChart = new GridChart({
      enableRtl: (grid as GridComponent).enableRtl,
      locale: (grid as GridComponent).locale,
    });
  }

  function contextMenuClick(args: ContextMenuClickEventArgs) {
    if (args.chartType) {
      const chartArgs = {
        gridInstance: (args.gridInstance as GridComponent),
        chartType: args.chartType,
        records: (args.records as SalesRecord[])
      };
      const chartModel: ChartModel = {
        primaryXAxis: {
          valueType: 'Category',
          labelRotation: 315
        }
      };
      const model: ChartChanges = {
        chart: chartModel,
        accumulationChart: {}
      };
      const categorySeries: CategorySeries = {
        category: ['Product', 'Month'],
        series: ['Online', 'Retail']
      };
      (gridChart as GridChart).render(chartArgs, model, categorySeries);
    }
  }

 return (
  <div>
    <GridComponent
      dataSource={salesDatas}
      height={340}
      ref={g => (grid = g)}
      created={created}
      contextMenuClick={contextMenuClick}
      allowSelection={true}
      contextMenuItems={[
        'Bar', 'StackingBar', 'StackingBar100',
        'Pie', 'Column', 'StackingColumn', 'StackingColumn100',
        'Line', 'StackingLine', 'StackingLine100',
        'Area', 'StackingArea', 'StackingArea100', 'Scatter'
      ]}
      selectionSettings={selectionSettings}
    >
      <ColumnsDirective>
        <ColumnDirective type="checkbox" width="50" />
        <ColumnDirective field="Product" headerText="Product" width="90" />
        <ColumnDirective field="Month" headerText="Month" width="180" />
        <ColumnDirective field="Online" headerText="Online" width="120" textAlign="Right" />
        <ColumnDirective field="Retail" headerText="Retail" width="110" textAlign="Right" />
        <ColumnDirective field="Total" headerText="Total" width="110" textAlign="Right" />
      </ColumnsDirective>
      <Inject services={[ContextMenu]} />
    </GridComponent>
  </div>
);

}

export default App;
export const salesDatas = [
  { Product: "Laptop", Month: "January", Online: 1500, Retail: 2000, Total: 3500 },
  { Product: "Mobile", Month: "February", Online: 1600, Retail: 2500, Total: 4100 },
  { Product: "Tablet", Month: "March", Online: 1800, Retail: 2200, Total: 4000 },
  { Product: "Smartwatch", Month: "April", Online: 2000, Retail: 2100, Total: 4100 },
  { Product: "Camera", Month: "May", Online: 2200, Retail: 2300, Total: 4500 },
  { Product: "Headphones", Month: "June", Online: 1700, Retail: 1800, Total: 3500 },
  { Product: "Smart Speaker", Month: "July", Online: 1900, Retail: 2000, Total: 3900 },
  { Product: "Printer", Month: "August", Online: 2100, Retail: 1900, Total: 4000 },
  { Product: "Monitor", Month: "September", Online: 2000, Retail: 1900, Total: 3900 },
  { Product: "Keyboard", Month: "October", Online: 1600, Retail: 1700, Total: 3300 },
  { Product: "Mouse", Month: "November", Online: 1700, Retail: 1600, Total: 3300 },
  { Product: "Router", Month: "December", Online: 1800, Retail: 2000, Total: 3800 }
];
export const salesDatas: Object[] = [
  { Product: "Laptop", Month: "January", Online: 1500, Retail: 2000, Total: 3500 },
  { Product: "Mobile", Month: "February", Online: 1600, Retail: 2500, Total: 4100 },
  { Product: "Tablet", Month: "March", Online: 1800, Retail: 2200, Total: 4000 },
  { Product: "Smartwatch", Month: "April", Online: 2000, Retail: 2100, Total: 4100 },
  { Product: "Camera", Month: "May", Online: 2200, Retail: 2300, Total: 4500 },
  { Product: "Headphones", Month: "June", Online: 1700, Retail: 1800, Total: 3500 },
  { Product: "Smart Speaker", Month: "July", Online: 1900, Retail: 2000, Total: 3900 },
  { Product: "Printer", Month: "August", Online: 2100, Retail: 1900, Total: 4000 },
  { Product: "Monitor", Month: "September", Online: 2000, Retail: 1900, Total: 3900 },
  { Product: "Keyboard", Month: "October", Online: 1600, Retail: 1700, Total: 3300 },
  { Product: "Mouse", Month: "November", Online: 1700, Retail: 1600, Total: 3300 },
  { Product: "Router", Month: "December", Online: 1800, Retail: 2000, Total: 3800 }
];

Enable export functionality in GridChart

GridChart export functionality enables saving or sharing charts in multiple formats. This is useful for preserving visualizations or including charts in reports and presentations.

Enable export by setting the allowExport property to true when creating the GridChart instance. Once enabled, an export option appears in the chart popup toolbar, allowing export to formats such as PDF, CSV, Print, JPEG, XLSX, SVG, and PNG.

gridChart = new GridChart({
  allowExport: true
});

When enabled, the property panel appears alongside the chart popup and offers three main configuration sections:

  • Chart Types: Choose from a variety of chart types, including Column, Line, Pie, and others.

  • Chart Data: Configure the category axis and series fields for data visualization.

  • Formatting Options: Adjust styling properties such as chart style, title style, legend appearance, series settings, and axes formatting.

    • Chart Style:

      • Margin: Adjust the margins around the chart (top, bottom, left, right) for better layout spacing.
      • Color: Set distinct colors for different chart elements to improve visual clarity.
    • Title Style

      • Legend: Toggle the visibility of the legend and customize its font, size, color, and position.
      • Series: Enable/disable tooltips and customize Series color and data labels based on categories such as online, retail, or revenue.
    • Axes: Select axes as either category or value type, and customize:

      • Reverse Order to change the data sequence.
      • Title: Adjust text, font, size, color, and rotation.
      • Label: Modify text, font, size, color, and rotation for better label presentation.

Customize the chart model:

Accumulation Charts (for example, pie charts) can be customized using the accumulationChart property of the model object. This property configures titles, legends, data labels, and visual styles for accumulation-type visualizations.

Additionally, Accumulation chart events can be used to apply extra customizations during rendering.

function contextMenuClick(args) 
{
  if (args.chartType) {
    const chartArgs = {
       gridInstance: args.gridInstance,
      chartType: args.chartType,
      records: args.records
    };
    const chartModel = {
      primaryXAxis: {
        valueType: 'Category',
        labelRotation: 315
      },
      margin: {
        top: 20,
        bottom: 20,
        right: 20,
        left: 20
      },
      tooltip: {
        enable: true,
        textStyle: {
          size: '16px',
          fontFamily: 'Arial, Helvetica, sans-serif'
        }
      },
      title: 'Sales Data',
      titleStyle: {
        size: '24px',
        fontFamily: 'Arial, Helvetica, sans-serif',
        fontWeight: 'Bold'
      },
      subTitle: 'Sales data for various products over the months',
      load: (args) => {
        if (args.chart.titleStyle) {
          args.chart.titleStyle.color = '#1976d2';
        }
      }
    };
    const accumulationChartModel = {
      title :'Sales Distribution'
    };
    const model = {
      chart: chartModel,
      accumulationChart: accumulationChartModel
    };
  }
}
function contextMenuClick(args: ContextMenuClickEventArgs) {
  if (args.chartType) {
    const chartModel: ChartModel = {
      primaryXAxis: {
        valueType: 'Category',
        labelRotation: 315
      },
      margin: {
        top: 20,
        bottom: 20,
        right: 20,
        left: 20
      },
      tooltip: {
        enable: true,
        textStyle: {
          size: '16px',
          fontFamily: 'Arial, Helvetica, sans-serif'
        }
      },
      title: 'Sales Data',
      titleStyle: {
        size: '24px',
        fontFamily: 'Arial, Helvetica, sans-serif',
        fontWeight: 'Bold'
      },
      subTitle: 'Sales data for various products over the months',
      load: (args: ILoadedEventArgs) => {
        if (args.chart.titleStyle) {
          args.chart.titleStyle.color = '#1976d2';
        }
      }
    };
    const accumulationChartModel: AccumulationChartModel = {
      title :'Sales Distribution'
    }

    // Combine both chart models into a single object.
    const model: ChartChanges = {
      chart: chartModel,
      accumulationChart: accumulationChartModel
    };
  }
}

Chart appearance can also be updated programmatically using the updateChartSettings event provided by the GridChart integration. This event triggers when chart properties are modified through the chart popup’s property panel. The event enables applying custom themes, adjusting axis settings, or modifying series styles.

The following code snippet demonstrates dynamically customizing chart margins and restricting their values to a minimum of “20” using the updateChartSettings event:

function created() {
  gridChart = new GridChart({
    enablePropertyPanel: true,
    allowExport: true,
    enableRtl: grid.enableRtl,
    locale: grid.locale,
    updateChartSettings: updateChartSettings
  });
}

function updateChartSettings(args) 
{
  const chart = args.changes.chart;
  if (!chart) return;
  const chartMargin = chart.margin;

  // Restrict margin values to minimum 20.
  if (chartMargin && !isNullOrUndefined(chartMargin)) {
    if (chartMargin.top < 20) chartMargin.top = 20;
    if (chartMargin.bottom < 20) chartMargin.bottom = 20;
    if (chartMargin.left < 20) chartMargin.left = 20;
    if (chartMargin.right < 20) chartMargin.right = 20;
  }
}
function created() {
  gridChart = new GridChart({
    enablePropertyPanel: true,
    allowExport: true,
    enableRtl: (grid as GridComponent).enableRtl,
    locale: (grid as GridComponent).locale,
    updateChartSettings: updateChartSettings
  });
}

function updateChartSettings(args: UpdateChartArgs) 
{
  const chart = args.changes.chart;
  if (!chart) return;

  // Restrict margin values to minimum 20.
  const chartMargin = chart.margin;
  if (chartMargin && !isNullOrUndefined(chartMargin)) {
    if (chartMargin.top < 20) chartMargin.top = 20;
    if (chartMargin.bottom < 20) chartMargin.bottom = 20;
    if (chartMargin.left < 20) chartMargin.left = 20;
    if (chartMargin.right < 20) chartMargin.right = 20;
  }
}

The following example demonstrates enabling the property panel by setting enablePropertyPanel to true, customizing the chart using the chartModel within contextMenuClick event, and dynamically controlling or customizing the behavior of the updateChartSettings event.

import { ColumnDirective, ColumnsDirective, ContextMenu, GridComponent, Inject } from '@syncfusion/ej2-react-grids';
import { GridChart} from '@syncfusion/ej2-grid-chart';
import * as React from 'react';
import { salesDatas } from './datasource';
import { isNullOrUndefined } from '@syncfusion/ej2-base';


function App() {
  let grid;
  let gridChart;
  const selectionSettings = { type: 'Multiple' };

  function created() {
    gridChart = new GridChart({
      enablePropertyPanel: true,
      allowExport: true,
      enableRtl: grid.enableRtl,
      locale: grid.locale,
      updateChartSettings: updateChartSettings
    });
  }

  function contextMenuClick(args) {
    if (args.chartType) {
      const chartArgs = {
        gridInstance: args.gridInstance,
        chartType: args.chartType,
        records: args.records
      };
      const chartModel = {
        primaryXAxis: {
          valueType: 'Category',
          labelRotation: 315
        },
        margin: {
          top: 20,
          bottom: 20,
          right: 20,
          left: 20
        },
        tooltip: {
          enable: true,
          textStyle: {
            size: '16px',
            fontFamily: 'Arial, Helvetica, sans-serif'
          }
        },
        title: 'Sales Data',
        titleStyle: {
          size: '24px',
          fontFamily: 'Arial, Helvetica, sans-serif',
          fontWeight: 'Bold'
        },
        subTitle: 'Sales data for various products over the months',
        load: (args) => {
          if (args.chart.titleStyle) {
            args.chart.titleStyle.color = '#1976d2';
          }
        }
      };
      const accumulationChartModel = {
        title :'Sales Distribution'
      };
      const model = {
        chart: chartModel,
        accumulationChart: accumulationChartModel
      };
      const categorySeries = {
        category: ['Product', 'Month'],
        series: ['Online', 'Retail']
      };
      gridChart.render(chartArgs, model, categorySeries);
    }
  }

  function updateChartSettings(args) {
    const chart = args.changes.chart;
    if (!chart) return;
    const chartMargin = chart.margin;
    if (chartMargin && !isNullOrUndefined(chartMargin)) {
      if (chartMargin.top < 20) chartMargin.top = 20;
      if (chartMargin.bottom < 20) chartMargin.bottom = 20;
      if (chartMargin.left < 20) chartMargin.left = 20;
      if (chartMargin.right < 20) chartMargin.right = 20;
    }
  }

  return (
    <div>
      <GridComponent dataSource={salesDatas} height={340} ref={g => grid = g}  created={created}
        contextMenuClick={contextMenuClick}
        allowSelection={true}
        contextMenuItems={[
          'Bar', 'StackingBar', 'StackingBar100',
          'Pie', 'Column', 'StackingColumn', 'StackingColumn100',
          'Line', 'StackingLine', 'StackingLine100',
          'Area', 'StackingArea', 'StackingArea100', 'Scatter'
        ]}
        selectionSettings={selectionSettings} >
        <ColumnsDirective>
          <ColumnDirective type='checkbox' width='50' />
          <ColumnDirective field='Product' headerText='Product' width='90' />
          <ColumnDirective field='Month' headerText='Month' width='180' />
          <ColumnDirective field='Online' headerText='Online' width='120' textAlign='Right' />
          <ColumnDirective field='Retail' headerText='Retail' width='110' textAlign='Right' />
          <ColumnDirective field='Total' headerText='Total' width='110' textAlign='Right' />
        </ColumnsDirective>
        <Inject services={[ContextMenu]} />
      </GridComponent>
    </div>
  );
}

export default App;
import { ColumnDirective, ColumnsDirective, ContextMenuClickEventArgs, ContextMenu,  GridComponent, Inject, SelectionSettingsModel} from '@syncfusion/ej2-react-grids';
import { GridChart, UpdateChartArgs, CategorySeries, ChartChanges } from '@syncfusion/ej2-grid-chart';
import { ChartModel, AccumulationChartModel, ILoadedEventArgs } from '@syncfusion/ej2-charts';
import * as React from 'react';
import { salesDatas } from './datasource';
import { isNullOrUndefined } from '@syncfusion/ej2-base';

interface SalesRecord {
  Product: string;
  Month: string;
  Online: number;
  Retail: number;
  Total: number;
}

function App() {
  let grid: GridComponent | null;
  let gridChart: GridChart;
  const selectionSettings: SelectionSettingsModel = { type: 'Multiple' };

  function created() {
    gridChart = new GridChart({
      enablePropertyPanel: true,
      allowExport: true,
      enableRtl: (grid as GridComponent).enableRtl,
      locale: (grid as GridComponent).locale,
      updateChartSettings: updateChartSettings
    });
  }

  function contextMenuClick(args: ContextMenuClickEventArgs) {
    if (args.chartType) {
      const chartArgs = {
        gridInstance: (args.gridInstance as GridComponent),
        chartType: args.chartType,
        records: (args.records as SalesRecord[])
      };
      const chartModel: ChartModel = {
        primaryXAxis: {
          valueType: 'Category',
          labelRotation: 315
        },
        margin: {
          top: 20,
          bottom: 20,
          right: 20,
          left: 20
        },
        tooltip: {
          enable: true,
          textStyle: {
            size: '16px',
            fontFamily: 'Arial, Helvetica, sans-serif'
          }
        },
        title: 'Sales Data',
        titleStyle: {
          size: '24px',
          fontFamily: 'Arial, Helvetica, sans-serif',
          fontWeight: 'Bold'
        },
        subTitle: 'Sales data for various products over the months',
        load: (args: ILoadedEventArgs) => {
          if (args.chart.titleStyle) {
            args.chart.titleStyle.color = '#1976d2';
          }
        }
      };
      const accumulationChartModel: AccumulationChartModel = {
        title :'Sales Distribution'
      }
      const model: ChartChanges = {
        chart: chartModel,
        accumulationChart: accumulationChartModel
      };
      const categorySeries: CategorySeries = {
        category: ['Product', 'Month'],
        series: ['Online', 'Retail']
      };
      (gridChart as GridChart).render(chartArgs, model, categorySeries);
    }
  }

  function updateChartSettings(args: UpdateChartArgs) {
    const chart = args.changes.chart;
    if (!chart) return;
    const chartMargin = chart.margin;
    if (chartMargin && !isNullOrUndefined(chartMargin)) {
      if (chartMargin.top < 20) chartMargin.top = 20;
      if (chartMargin.bottom < 20) chartMargin.bottom = 20;
      if (chartMargin.left < 20) chartMargin.left = 20;
      if (chartMargin.right < 20) chartMargin.right = 20;
    }
  }

  return (
    <div>
      <GridComponent
        dataSource={salesDatas}
        height={340}
        ref={g => (grid = g)}
        created={created}
        contextMenuClick={contextMenuClick}
        allowSelection={true}
        contextMenuItems={[
          'Bar', 'StackingBar', 'StackingBar100',
          'Pie', 'Column', 'StackingColumn', 'StackingColumn100',
          'Line', 'StackingLine', 'StackingLine100',
          'Area', 'StackingArea', 'StackingArea100', 'Scatter'
        ]}
        selectionSettings={selectionSettings}
      >
        <ColumnsDirective>
          <ColumnDirective type="checkbox" width="50" />
          <ColumnDirective field="Product" headerText="Product" width="90" />
          <ColumnDirective field="Month" headerText="Month" width="180" />
          <ColumnDirective field="Online" headerText="Online" width="120" textAlign="Right" />
          <ColumnDirective field="Retail" headerText="Retail" width="110" textAlign="Right" />
          <ColumnDirective field="Total" headerText="Total" width="110" textAlign="Right" />
        </ColumnsDirective>
        <Inject services={[ContextMenu]} />
      </GridComponent>
    </div>
  );
}

export default App;
export const salesDatas = [
  { Product: "Laptop", Month: "January", Online: 1500, Retail: 2000, Total: 3500 },
  { Product: "Mobile", Month: "February", Online: 1600, Retail: 2500, Total: 4100 },
  { Product: "Tablet", Month: "March", Online: 1800, Retail: 2200, Total: 4000 },
  { Product: "Smartwatch", Month: "April", Online: 2000, Retail: 2100, Total: 4100 },
  { Product: "Camera", Month: "May", Online: 2200, Retail: 2300, Total: 4500 },
  { Product: "Headphones", Month: "June", Online: 1700, Retail: 1800, Total: 3500 },
  { Product: "Smart Speaker", Month: "July", Online: 1900, Retail: 2000, Total: 3900 },
  { Product: "Printer", Month: "August", Online: 2100, Retail: 1900, Total: 4000 },
  { Product: "Monitor", Month: "September", Online: 2000, Retail: 1900, Total: 3900 },
  { Product: "Keyboard", Month: "October", Online: 1600, Retail: 1700, Total: 3300 },
  { Product: "Mouse", Month: "November", Online: 1700, Retail: 1600, Total: 3300 },
  { Product: "Router", Month: "December", Online: 1800, Retail: 2000, Total: 3800 }
];
export const salesDatas: Object[] = [
  { Product: "Laptop", Month: "January", Online: 1500, Retail: 2000, Total: 3500 },
  { Product: "Mobile", Month: "February", Online: 1600, Retail: 2500, Total: 4100 },
  { Product: "Tablet", Month: "March", Online: 1800, Retail: 2200, Total: 4000 },
  { Product: "Smartwatch", Month: "April", Online: 2000, Retail: 2100, Total: 4100 },
  { Product: "Camera", Month: "May", Online: 2200, Retail: 2300, Total: 4500 },
  { Product: "Headphones", Month: "June", Online: 1700, Retail: 1800, Total: 3500 },
  { Product: "Smart Speaker", Month: "July", Online: 1900, Retail: 2000, Total: 3900 },
  { Product: "Printer", Month: "August", Online: 2100, Retail: 1900, Total: 4000 },
  { Product: "Monitor", Month: "September", Online: 2000, Retail: 1900, Total: 3900 },
  { Product: "Keyboard", Month: "October", Online: 1600, Retail: 1700, Total: 3300 },
  { Product: "Mouse", Month: "November", Online: 1700, Retail: 1600, Total: 3300 },
  { Product: "Router", Month: "December", Online: 1800, Retail: 2000, Total: 3800 }
];